require 'set'
require File.dirname(__FILE__) + '/search'

class BFS
  def initialize(options)
    queue = []
    marked = Set.new
    marked << options[:start]
    scheduler = Proc.new do |states|
      states.each do |state|
        if !marked.include?(state)
          queue << state
          marked << state
        end
      end
      queue.shift
    end

    @search = Search.new(start: options[:start],
                         generator: options[:generator],
                         scheduler: scheduler)
  end

  def method_missing(meth, *args, &block)
    @search.send(meth, *args, &block)
  end
end
