require 'set'
require File.dirname(__FILE__) + '/search'

class DFS
  def initialize(options)

    stack = []
    marked = Set.new
    marked << options[:start]

    scheduler = Proc.new do |states|
      states.reverse.each do |state|
        stack << state if !marked.include?(state)
        marked << state
      end
      stack.pop
    end

    @search = Search.new(start: options[:start],
                         generator: options[:generator],
                         scheduler: scheduler)
  end

  def method_missing(meth, *args, &block)
    @search.send(meth, *args, &block)
  end
end
